/**
 * @file
 * @brief Exception for parts that are not implemented
 * @author  Andreas Maier <a.maier@tum.de>
 * @version 1.0.0
 *
 * @section LICENSE
 *
 * Copyright 2014, 2015 Andreas Maier
 *
 * This file is part of the QQbar_threshold library.
 *
 * The QQbar_threshold library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 3 of
 * the License, or (at your option) any later version.
 *
 * The QQbar_threshold library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the QQbar_threshold library. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 */
#pragma once

#include <exception>

namespace QQbar_threshold{
  //! Exception class for functionality that is not implemented
  class not_implemented : public std::runtime_error{
  public:
    explicit not_implemented( const std::string& what_arg ) : std::runtime_error(what_arg) {}
    explicit not_implemented( const char * what_arg ) : std::runtime_error(what_arg) {}
  };
}
