#ifdef NDEBUG
#undef NDEBUG
#endif
#include <iostream>
#include <iomanip>
#include <array>

#include "Wilson_coefficients.hpp"
#include "xsection.hpp"
#include "load_grid.hpp"
#include "threshold.hpp"

#define TSTT(name,i) \
  std::cout << #name << ": "; \
  diff = name - results_top[i]; \
  std::cout << diff; \
  assert(std::abs(diff)/std::abs(results_top[i]) < ep);	\
  std::cout << " (ok)\n";


namespace qqt = QQbar_threshold;
int main(){
  using namespace QQbar_threshold::pert_order;
  double constexpr ep = 1e-10;
  using QQbar_threshold::top_options;
  using zeta::pi;
  double diff;
  QQbar_threshold::load_grid("../grids/ttbar_grid.tsv");
  auto opt = top_options();
  //TODO: PS/PSshift
  opt.mass_scheme.name = qqt::Pole;
  //TODO: turn on pole resummation
  opt.resum_poles = 0;
  //constexpr double mt = 171.5;
  constexpr double mt_pole = 173;
  constexpr double width = 1.33;

  opt.alpha_s_mZ = 0.1185;
  constexpr std::array<double, 2> results_top = {{
      0.98455955428773367366,
      0.88650314849596534295
    }};
  TSTT(ttbar_R_ratio(qqt::threshold(), {80, 350}, {mt_pole, width}, N2LO, opt),0);
  TSTT(ttbar_R_ratio(qqt::threshold(), {80, 350}, {mt_pole, width}, N3LO, opt),1);

  opt = qqt::bottom_options();

  QQbar_threshold::load_grid("../grids/bbbar_grid.tsv");
  opt.contributions.Cv_QED[0] = 0;
  opt.contributions.Ca_QED[0] = 0;
  opt.contributions.Cv_WZ[0] = 0;
  opt.contributions.Ca_WZ[0] = 0;
  double no_EW = bbbar_R_ratio(qqt::threshold()+1e-3, 5, 5, N3LO, opt);
  opt.contributions.Cv_QED[0] = 1;
  opt.contributions.Ca_QED[0] = 1;
  opt.contributions.Cv_WZ[0] = 1;
  opt.contributions.Ca_WZ[0] = 1;
  double with_EW = bbbar_R_ratio(qqt::threshold()+1e-3, 5, 5, N3LO, opt);
  diff = no_EW-with_EW;
  std::cout << "bottom sanity test: " << diff;
  assert(diff < 1e-3);
  std::cout << " (ok)\n";
}
